from PG_utils import *
from PG import PolicyNet, collect_data
from FQE_PG import FQE_PG
import torch
from torch.autograd import Variable

def flatten(lst):
    result = []
    for sublst in lst:
        result.extend(sublst)
    return result

def set_flat_grads_to(model, flat_grads):
    prev_ind = 0
    for param in model.parameters():
        flat_size = int(np.prod(list(param.size())))
        param.grad = Variable(flat_grads[prev_ind:prev_ind + flat_size].view(param.size()))
        prev_ind += flat_size

def compute_gradient(env, features, next_states, rewards, policy_net, feature, H, d, m, sample_s, lam):
    grad, _ , __ = FQE_PG(env, features, next_states, rewards, policy_net, feature, H, d, m, sample_s=sample_s, lam=lam)
    set_flat_grads_to(policy_net, torch.from_numpy(-grad).float())

def FQE_REINFORCE(policy_net, optimizer, env, feature, num_episode, gamma, N, H, d, m, lam=0, sample_s=100, window_len=5):
    score_his = []
    result = []
    bar = range(num_episode)

    features_lst, next_states_lst, rewards_lst = [], [], []

    for i in bar:
        states, actions, next_states, rewards = collect_data(env, policy_net, N, H)
        features = get_features(states, actions, feature)

        score_his += get_cumu_discounted_rewards(rewards, 1)
        result.append(print_score(score_his))

        if len(features_lst) >= window_len:
            features_lst.pop(0)
            next_states_lst.pop(0)
            rewards_lst.pop(0)
        features_lst.append(features)
        next_states_lst.append(next_states)
        rewards_lst.append(rewards)
        curr_features, curr_next_states, curr_rewards = flatten(features_lst), flatten(next_states_lst), flatten(rewards_lst)

        optimizer.zero_grad()
        compute_gradient(env, curr_features, curr_next_states, curr_rewards, policy_net, feature, H, d, m, sample_s, lam)
        optimizer.step()

    return result
