from FQE_PG import *
from FQE_PG_utils import *
from Featurizer import *
from PG import PG, sample_gradient, collect_data, PolicyNet, sample_gradient_w
from PG_utils import get_features, EnvWrapper, set_seed
from FQE_REINFORCE import FQE_REINFORCE
import gym

# initialize
env_name = "FrozenLake-v1"
env = gym.make(env_name)
n_state = env.observation_space.n
n_action = env.action_space.n
env = EnvWrapper(env)

# set seed_init
seed_init = 1000
set_seed(env, seed_init)

# create feature
feature, d = create_tabular_feature(n_state, n_action)


lr = 0.05
num_episode = 200
N = 100
H = 100
gamma = 1

lr_FPG = 0.05
N_FPG = 100
window_len = 5
lam = 0.001
sample_s = 1000

PG_lst, FQE_lst = [], []
seed_lst = [x for x in range(10, 11)]
for seed_i in seed_lst:
    set_seed(env, seed_i)
    policy_net = PolicyNet(n_state, n_action)
    m = net_param_num(policy_net)
    optimizer = torch.optim.Adam(policy_net.parameters(), lr=lr)
    score_his = PG(policy_net, optimizer, env, num_episode, gamma, N, H)
    PG_lst.append(score_his)

    set_seed(env, seed_i)
    policy_net = PolicyNet(n_state, n_action)
    m = net_param_num(policy_net)
    optimizer = torch.optim.Adam(policy_net.parameters(), lr=lr_FPG)
    score_his = FQE_REINFORCE(policy_net, optimizer, env, feature, num_episode, gamma, N_FPG, H, d, m, lam=lam, sample_s=sample_s, window_len=window_len)
    FQE_lst.append(score_his)

store_result(PG_lst, "result/PG_lr" + str(lr) + "_H" + str(H) + "_N" + str(N) + "_eps" + str(num_episode) + ".pickle")
store_result(FQE_lst, "result/FPG_lr" + str(lr_FPG) + "_H" + str(H) + "_N" + str(N_FPG) + "_window_" + str(window_len) + "_eps" + str(num_episode) + ".pickle")
