from FQE_PG import *
from FQE_PG_utils import *
from Featurizer import *
from PG import PG, sample_gradient, collect_data, PolicyNet, sample_gradient_w
from PG_utils import get_features, EnvWrapper, set_seed
from OP_REINFORCE import *
import gym

# initialize
env_name = "FrozenLake-v1"
env = gym.make(env_name)
n_state = env.observation_space.n
n_action = env.action_space.n
env = EnvWrapper(env)

# set seed_init
seed_init = 1000
set_seed(env, seed_init)

# create feature
feature, d = create_tabular_feature(n_state, n_action)

# optimal policy via PG
K = 500
eps_behavior = 0.3
lr_PG = 0.1
num_episode = 200
#H = 100

lr_FPG = 0.1
lam = 0.001
sample_s = 1000

lr = 0.1
num_episode_p = 200
N = 100
H = 100
gamma = 1

policy_net = PolicyNet(n_state, n_action)
optimizer = torch.optim.Adam(policy_net.parameters(), lr=lr)
score_his = PG(policy_net, optimizer, env, num_episode_p, gamma, N, H)

OPPG_lst, OPFPG_lst = [], []
seed_lst = [x for x in range(10, 15)]
for seed_i in seed_lst:
    set_seed(env, seed_i)
    states, actions, next_states, rewards = collect_data(env, policy_net, K, H, eps=eps_behavior)

    set_seed(env, seed_i)
    policy_net = PolicyNet(n_state, n_action)
    m = net_param_num(policy_net)
    optimizer = torch.optim.Adam(policy_net.parameters(), lr=lr_PG)
    score_his = OPPG(states, actions, next_states, rewards, policy_net, optimizer, env, num_episode, gamma, H, eps_behavior)
    OPPG_lst.append(score_his)

    set_seed(env, seed_i)
    policy_net = PolicyNet(n_state, n_action)
    m = net_param_num(policy_net)
    optimizer = torch.optim.Adam(policy_net.parameters(), lr=lr_FPG)
    score_his = OPFPG(states, actions, next_states, rewards, policy_net, optimizer, env, feature, num_episode, gamma, H, d, m, lam=lam, sample_s=sample_s)
    OPFPG_lst.append(score_his)

store_result(OPPG_lst, "result/OPPG_eps" + str(eps_behavior) + "_lr" + str(lr_PG) + "_H" + str(H) + "_K" + str(K) + "_eps" + str(num_episode) + ".pickle")
store_result(OPFPG_lst, "result/OPFPG_eps" + str(eps_behavior) + "_lr" + str(lr_FPG) + "_H" + str(H) + "_K" + str(K) + "_eps" + str(num_episode) + ".pickle")
