from FQE_PG import *
from FQE_PG_utils import *
from Featurizer import *
from PG import PG, sample_gradient, collect_data, PolicyNet, sample_gradient_w
from PG_utils import get_features, set_seed
from SVRPG import *
import gym

# initialize
env_name = "FrozenLake-v1"
env = gym.make(env_name)
n_state = env.observation_space.n
n_action = env.action_space.n
#env = EnvWrapper(env)


lr = 0.1
num_episode = 200
N = 100
H = 100
gamma = 1

result_lst = []
seed_lst = [x for x in range(10, 11)]
for seed_i in seed_lst:
    set_seed(env, seed_i)
    policy_net = PolicyNet(n_state, n_action)
    m = net_param_num(policy_net)
    optimizer = torch.optim.Adam(policy_net.parameters(), lr=lr)
    score_his = SVRPG(policy_net, optimizer, env, num_episode, lr, gamma, N, int(N ** (1/2)), int(N ** (1/2)), H, n_state, n_action, delta=0.01)
    result_lst.append(score_his)

store_result(result_lst, "result/SVRPG_lr" + str(lr) + "_H" + str(H) + "_N" + str(N) + "_eps" + str(num_episode) + ".pickle")
