import gym
from FQE_PG import FQE_PG
from FQE_PG_utils import *

def bootstrap_FQE(env, features, next_states, rewards, policy_net, feature, H, d, m, B, sample_s=100, lam=0.0, skip=None):
    K = len(features)
    result_lst = []
    result, _ = FQE_PG(env, features, next_states, rewards, policy_net, feature, H, d, m, sample_s=sample_s, lam=lam)
    if skip is not None:
        for _ in range(skip):
            np.random.choice(K)
    for b in range(B):
        index_lst = [np.random.choice(K) for _ in range(K)]
        new_features, new_next_states, new_rewards = [], [], []
        for index in index_lst:
            new_features.append(features[index])
            new_next_states.append(next_states[index])
            new_rewards.append(rewards[index])
        result_b, _ = FQE_PG(env, new_features, new_next_states, new_rewards, policy_net, feature, H, d, m, sample_s=sample_s, lam=lam)
        result_lst.append(result_b)
    return result, result_lst
