from FQE_PG import *
from bootstrap import bootstrap_FQE
from FQE_PG_utils import *
from Featurizer import *
from PG import PG, sample_gradient, collect_data, PolicyNet, sample_gradient_w
from PG_utils import get_features, EnvWrapper, set_seed
import gym

# initialize
env_name = "FrozenLake-v1"
env = gym.make(env_name)
n_state = env.observation_space.n
n_action = env.action_space.n
env = EnvWrapper(env)

# set seed_init
seed_init = 1000
set_seed(env, seed_init)

# create feature
feature, d = create_tabular_feature(n_state, n_action)

# optimal policy via PG
lr = 0.05
num_episode = 200
N = 100
H = 100
gamma = 1
policy_net = PolicyNet(n_state, n_action)
optimizer = torch.optim.Adam(policy_net.parameters(), lr=lr)
score_his = PG(policy_net, optimizer, env, num_episode, gamma, N, H)

# generate off-policy data: on-policy
B = 100
skip_n = None
K = 200
lam = 0.001
sample_s = 1000
eps_behavior = 0.1
m = net_param_num(policy_net)

seed_lst = [x for x in range(10, 11)]
for seed_i in seed_lst:
    set_seed(env, seed_i)
    states, actions, next_states, rewards = collect_data(env, policy_net, K, H, eps_behavior)
    features = get_features(states, actions, feature)

    # bootstrap
    result_lst = bootstrap_FQE(env, features, next_states, rewards, policy_net, feature, H, d, m, B, sample_s=sample_s, lam=lam, skip=skip_n)

store_result(result_lst, "result/bootstrap_B" + str(B) + "_K" + str(K) + "_H" + str(H) + "_lam" + str(lam) + "_eps" + str(eps_behavior) + ".pickle")
